; -*-Emacs-Lisp-*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; File:         gnus-newsgroup-sort.el
; Description:  A command to sort a gnus newsgroup list
; Author:       Carl Edman
; Created:      Wed Feb 12 21:00:33 1990 (Carl Edman) cedman@golem.ps.uci.edu
; Modified:     Wed Apr 17 23:05:59 1991 (Carl Edman) cedman@lynx
; Language:     Emacs-Lisp
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; To setup simply add these line to your "~/.emacs" file:
;
; (autoload 'gnus-newsgroup-sort "gnus-newsgroup-sort" "A function to sort newsgroups inside gnus." t nil)
; (setq gnus-Save-newsgroup 'gnus-newsgroup-sort)
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;

(provide 'gnus-newsgroup-sort)

(defvar gnus-newsgroup-sort-list nil)

(defun gnus-newsgroup-sort-index (str)
  (let ((l gnus-newsgroup-sort-list) (counter 0))
    (while (and l (not (string-match (car l) str)))
      (setq l (cdr l))
      (setq counter (+ counter 1)))
    counter))

(defun gnus-newsgroup-sort ()
  (let ((l gnus-newsrc-assoc))
    (while l
      (setcar l (cons (gnus-newsgroup-sort-index (car (car l))) (car l)))
      (setq l (cdr l)))
    (setq gnus-newsrc-assoc
          (sort gnus-newsrc-assoc
                (function
                 (lambda (e1 e2)
                   (cond
                    ((< (car e1) (car e2)) t)
                    ((> (car e1) (car e2)) nil)
                    (t (string< (car (cdr e1)) (car (cdr e2)))))))))
    (setq l gnus-newsrc-assoc)
    (while l
      (setcar l (cdr (car l)))
      (setq l (cdr l)))))
